# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetSCIMGroupsResult',
    'AwaitableGetSCIMGroupsResult',
    'get_scim_groups',
    'get_scim_groups_output',
]

@pulumi.output_type
class GetSCIMGroupsResult:
    """
    A collection of values returned by getSCIMGroups.
    """
    def __init__(__self__, creation_time=None, id=None, idp_group_id=None, idp_id=None, idp_name=None, modified_time=None, name=None):
        if creation_time and not isinstance(creation_time, int):
            raise TypeError("Expected argument 'creation_time' to be a int")
        pulumi.set(__self__, "creation_time", creation_time)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if idp_group_id and not isinstance(idp_group_id, str):
            raise TypeError("Expected argument 'idp_group_id' to be a str")
        pulumi.set(__self__, "idp_group_id", idp_group_id)
        if idp_id and not isinstance(idp_id, int):
            raise TypeError("Expected argument 'idp_id' to be a int")
        pulumi.set(__self__, "idp_id", idp_id)
        if idp_name and not isinstance(idp_name, str):
            raise TypeError("Expected argument 'idp_name' to be a str")
        pulumi.set(__self__, "idp_name", idp_name)
        if modified_time and not isinstance(modified_time, int):
            raise TypeError("Expected argument 'modified_time' to be a int")
        pulumi.set(__self__, "modified_time", modified_time)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="creationTime")
    def creation_time(self) -> builtins.int:
        return pulumi.get(self, "creation_time")

    @property
    @pulumi.getter
    def id(self) -> Optional[builtins.str]:
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="idpGroupId")
    def idp_group_id(self) -> builtins.str:
        return pulumi.get(self, "idp_group_id")

    @property
    @pulumi.getter(name="idpId")
    def idp_id(self) -> Optional[builtins.int]:
        return pulumi.get(self, "idp_id")

    @property
    @pulumi.getter(name="idpName")
    def idp_name(self) -> Optional[builtins.str]:
        return pulumi.get(self, "idp_name")

    @property
    @pulumi.getter(name="modifiedTime")
    def modified_time(self) -> builtins.int:
        return pulumi.get(self, "modified_time")

    @property
    @pulumi.getter
    def name(self) -> Optional[builtins.str]:
        return pulumi.get(self, "name")


class AwaitableGetSCIMGroupsResult(GetSCIMGroupsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSCIMGroupsResult(
            creation_time=self.creation_time,
            id=self.id,
            idp_group_id=self.idp_group_id,
            idp_id=self.idp_id,
            idp_name=self.idp_name,
            modified_time=self.modified_time,
            name=self.name)


def get_scim_groups(id: Optional[builtins.str] = None,
                    idp_id: Optional[builtins.int] = None,
                    idp_name: Optional[builtins.str] = None,
                    name: Optional[builtins.str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSCIMGroupsResult:
    """
    * [Official documentation](https://help.zscaler.com/zpa/about-scim-groups)
    * [API documentation](https://help.zscaler.com/zpa/obtaining-scim-group-details-using-api)

    Use the **zpa_scim_groups** data source to get information about a SCIM Group from an Identity Provider (IdP). This data source can then be referenced in an Access Policy, Timeout policy, Forwarding Policy, Inspection Policy or Isolation Policy.

    **NOTE:** To ensure consistent search results across data sources, please avoid using multiple spaces or special characters in your search queries.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_zpa as zpa

    engineering = zpa.get_scim_groups(idp_name="idp_name",
        name="Engineering")
    ```
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['idpId'] = idp_id
    __args__['idpName'] = idp_name
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('zpa:index/getSCIMGroups:getSCIMGroups', __args__, opts=opts, typ=GetSCIMGroupsResult).value

    return AwaitableGetSCIMGroupsResult(
        creation_time=pulumi.get(__ret__, 'creation_time'),
        id=pulumi.get(__ret__, 'id'),
        idp_group_id=pulumi.get(__ret__, 'idp_group_id'),
        idp_id=pulumi.get(__ret__, 'idp_id'),
        idp_name=pulumi.get(__ret__, 'idp_name'),
        modified_time=pulumi.get(__ret__, 'modified_time'),
        name=pulumi.get(__ret__, 'name'))
def get_scim_groups_output(id: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                           idp_id: Optional[pulumi.Input[Optional[builtins.int]]] = None,
                           idp_name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                           name: Optional[pulumi.Input[Optional[builtins.str]]] = None,
                           opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetSCIMGroupsResult]:
    """
    * [Official documentation](https://help.zscaler.com/zpa/about-scim-groups)
    * [API documentation](https://help.zscaler.com/zpa/obtaining-scim-group-details-using-api)

    Use the **zpa_scim_groups** data source to get information about a SCIM Group from an Identity Provider (IdP). This data source can then be referenced in an Access Policy, Timeout policy, Forwarding Policy, Inspection Policy or Isolation Policy.

    **NOTE:** To ensure consistent search results across data sources, please avoid using multiple spaces or special characters in your search queries.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_zpa as zpa

    engineering = zpa.get_scim_groups(idp_name="idp_name",
        name="Engineering")
    ```
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['idpId'] = idp_id
    __args__['idpName'] = idp_name
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('zpa:index/getSCIMGroups:getSCIMGroups', __args__, opts=opts, typ=GetSCIMGroupsResult)
    return __ret__.apply(lambda __response__: GetSCIMGroupsResult(
        creation_time=pulumi.get(__response__, 'creation_time'),
        id=pulumi.get(__response__, 'id'),
        idp_group_id=pulumi.get(__response__, 'idp_group_id'),
        idp_id=pulumi.get(__response__, 'idp_id'),
        idp_name=pulumi.get(__response__, 'idp_name'),
        modified_time=pulumi.get(__response__, 'modified_time'),
        name=pulumi.get(__response__, 'name')))
