# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['InspectionCustomControlsArgs', 'InspectionCustomControls']

@pulumi.input_type
class InspectionCustomControlsArgs:
    def __init__(__self__, *,
                 severity: pulumi.Input[builtins.str],
                 type: pulumi.Input[builtins.str],
                 control_type: Optional[pulumi.Input[builtins.str]] = None,
                 default_action: Optional[pulumi.Input[builtins.str]] = None,
                 default_action_value: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 paranoia_level: Optional[pulumi.Input[builtins.str]] = None,
                 protocol_type: Optional[pulumi.Input[builtins.str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a InspectionCustomControls resource.
        :param pulumi.Input[builtins.str] severity: Severity of the control number
        :param pulumi.Input[builtins.str] type: Rules to be applied to the request or response type
        :param pulumi.Input[builtins.str] default_action: The performed action
        :param pulumi.Input[builtins.str] default_action_value: This is used to provide the redirect URL if the default action is set to REDIRECT
        :param pulumi.Input[builtins.str] description: Description of the custom control
        :param pulumi.Input[builtins.str] paranoia_level: OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        :param pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]] rules: Rules of the custom controls applied as conditions (JSON)
        """
        pulumi.set(__self__, "severity", severity)
        pulumi.set(__self__, "type", type)
        if control_type is not None:
            pulumi.set(__self__, "control_type", control_type)
        if default_action is not None:
            pulumi.set(__self__, "default_action", default_action)
        if default_action_value is not None:
            pulumi.set(__self__, "default_action_value", default_action_value)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if paranoia_level is not None:
            pulumi.set(__self__, "paranoia_level", paranoia_level)
        if protocol_type is not None:
            pulumi.set(__self__, "protocol_type", protocol_type)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter
    def severity(self) -> pulumi.Input[builtins.str]:
        """
        Severity of the control number
        """
        return pulumi.get(self, "severity")

    @severity.setter
    def severity(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "severity", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[builtins.str]:
        """
        Rules to be applied to the request or response type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="controlType")
    def control_type(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "control_type")

    @control_type.setter
    def control_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "control_type", value)

    @property
    @pulumi.getter(name="defaultAction")
    def default_action(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The performed action
        """
        return pulumi.get(self, "default_action")

    @default_action.setter
    def default_action(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_action", value)

    @property
    @pulumi.getter(name="defaultActionValue")
    def default_action_value(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        This is used to provide the redirect URL if the default action is set to REDIRECT
        """
        return pulumi.get(self, "default_action_value")

    @default_action_value.setter
    def default_action_value(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_action_value", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Description of the custom control
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="paranoiaLevel")
    def paranoia_level(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        """
        return pulumi.get(self, "paranoia_level")

    @paranoia_level.setter
    def paranoia_level(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "paranoia_level", value)

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "protocol_type")

    @protocol_type.setter
    def protocol_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "protocol_type", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]]]:
        """
        Rules of the custom controls applied as conditions (JSON)
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)


@pulumi.input_type
class _InspectionCustomControlsState:
    def __init__(__self__, *,
                 control_type: Optional[pulumi.Input[builtins.str]] = None,
                 default_action: Optional[pulumi.Input[builtins.str]] = None,
                 default_action_value: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 paranoia_level: Optional[pulumi.Input[builtins.str]] = None,
                 protocol_type: Optional[pulumi.Input[builtins.str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]]] = None,
                 severity: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering InspectionCustomControls resources.
        :param pulumi.Input[builtins.str] default_action: The performed action
        :param pulumi.Input[builtins.str] default_action_value: This is used to provide the redirect URL if the default action is set to REDIRECT
        :param pulumi.Input[builtins.str] description: Description of the custom control
        :param pulumi.Input[builtins.str] paranoia_level: OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        :param pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]] rules: Rules of the custom controls applied as conditions (JSON)
        :param pulumi.Input[builtins.str] severity: Severity of the control number
        :param pulumi.Input[builtins.str] type: Rules to be applied to the request or response type
        """
        if control_type is not None:
            pulumi.set(__self__, "control_type", control_type)
        if default_action is not None:
            pulumi.set(__self__, "default_action", default_action)
        if default_action_value is not None:
            pulumi.set(__self__, "default_action_value", default_action_value)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if paranoia_level is not None:
            pulumi.set(__self__, "paranoia_level", paranoia_level)
        if protocol_type is not None:
            pulumi.set(__self__, "protocol_type", protocol_type)
        if rules is not None:
            pulumi.set(__self__, "rules", rules)
        if severity is not None:
            pulumi.set(__self__, "severity", severity)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if version is not None:
            pulumi.set(__self__, "version", version)

    @property
    @pulumi.getter(name="controlType")
    def control_type(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "control_type")

    @control_type.setter
    def control_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "control_type", value)

    @property
    @pulumi.getter(name="defaultAction")
    def default_action(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The performed action
        """
        return pulumi.get(self, "default_action")

    @default_action.setter
    def default_action(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_action", value)

    @property
    @pulumi.getter(name="defaultActionValue")
    def default_action_value(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        This is used to provide the redirect URL if the default action is set to REDIRECT
        """
        return pulumi.get(self, "default_action_value")

    @default_action_value.setter
    def default_action_value(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "default_action_value", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Description of the custom control
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="paranoiaLevel")
    def paranoia_level(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        """
        return pulumi.get(self, "paranoia_level")

    @paranoia_level.setter
    def paranoia_level(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "paranoia_level", value)

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "protocol_type")

    @protocol_type.setter
    def protocol_type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "protocol_type", value)

    @property
    @pulumi.getter
    def rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]]]:
        """
        Rules of the custom controls applied as conditions (JSON)
        """
        return pulumi.get(self, "rules")

    @rules.setter
    def rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['InspectionCustomControlsRuleArgs']]]]):
        pulumi.set(self, "rules", value)

    @property
    @pulumi.getter
    def severity(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Severity of the control number
        """
        return pulumi.get(self, "severity")

    @severity.setter
    def severity(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "severity", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Rules to be applied to the request or response type
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def version(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "version")

    @version.setter
    def version(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version", value)


@pulumi.type_token("zpa:index/inspectionCustomControls:InspectionCustomControls")
class InspectionCustomControls(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 control_type: Optional[pulumi.Input[builtins.str]] = None,
                 default_action: Optional[pulumi.Input[builtins.str]] = None,
                 default_action_value: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 paranoia_level: Optional[pulumi.Input[builtins.str]] = None,
                 protocol_type: Optional[pulumi.Input[builtins.str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['InspectionCustomControlsRuleArgs', 'InspectionCustomControlsRuleArgsDict']]]]] = None,
                 severity: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-custom-controls)
        * [API documentation](https://help.zscaler.com/zpa/configuring-appprotection-controls-using-api)

        The **zpa_inspection_custom_controls** resource creates an inspection custom control. This resource can then be referenced in an inspection profile resource.

        ## Example - Inspection Custom Control - PASS Action

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.InspectionCustomControls("this",
            default_action="PASS",
            description="Example",
            paranoia_level="1",
            rules=[
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "names": ["this"],
                    "type": "RESPONSE_HEADERS",
                },
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "type": "RESPONSE_BODY",
                },
            ],
            severity="CRITICAL",
            type="RESPONSE")
        ```

        ## Example - Inspection Custom Control - BLOCK Action

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.InspectionCustomControls("this",
            default_action="BLOCK",
            description="Example",
            paranoia_level="1",
            rules=[
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "names": ["this"],
                    "type": "RESPONSE_HEADERS",
                },
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "type": "RESPONSE_BODY",
                },
            ],
            severity="CRITICAL",
            type="RESPONSE")
        ```

        ## Example - Inspection Custom Control - REDIRECT Action

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.InspectionCustomControls("this",
            default_action="REDIRECT",
            default_action_value="https://test.com",
            description="Example",
            paranoia_level="1",
            rules=[
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "names": ["this"],
                    "type": "RESPONSE_HEADERS",
                },
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "type": "RESPONSE_BODY",
                },
            ],
            severity="CRITICAL",
            type="RESPONSE")
        ```

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] default_action: The performed action
        :param pulumi.Input[builtins.str] default_action_value: This is used to provide the redirect URL if the default action is set to REDIRECT
        :param pulumi.Input[builtins.str] description: Description of the custom control
        :param pulumi.Input[builtins.str] paranoia_level: OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        :param pulumi.Input[Sequence[pulumi.Input[Union['InspectionCustomControlsRuleArgs', 'InspectionCustomControlsRuleArgsDict']]]] rules: Rules of the custom controls applied as conditions (JSON)
        :param pulumi.Input[builtins.str] severity: Severity of the control number
        :param pulumi.Input[builtins.str] type: Rules to be applied to the request or response type
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InspectionCustomControlsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-custom-controls)
        * [API documentation](https://help.zscaler.com/zpa/configuring-appprotection-controls-using-api)

        The **zpa_inspection_custom_controls** resource creates an inspection custom control. This resource can then be referenced in an inspection profile resource.

        ## Example - Inspection Custom Control - PASS Action

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.InspectionCustomControls("this",
            default_action="PASS",
            description="Example",
            paranoia_level="1",
            rules=[
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "names": ["this"],
                    "type": "RESPONSE_HEADERS",
                },
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "type": "RESPONSE_BODY",
                },
            ],
            severity="CRITICAL",
            type="RESPONSE")
        ```

        ## Example - Inspection Custom Control - BLOCK Action

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.InspectionCustomControls("this",
            default_action="BLOCK",
            description="Example",
            paranoia_level="1",
            rules=[
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "names": ["this"],
                    "type": "RESPONSE_HEADERS",
                },
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "type": "RESPONSE_BODY",
                },
            ],
            severity="CRITICAL",
            type="RESPONSE")
        ```

        ## Example - Inspection Custom Control - REDIRECT Action

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.InspectionCustomControls("this",
            default_action="REDIRECT",
            default_action_value="https://test.com",
            description="Example",
            paranoia_level="1",
            rules=[
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "names": ["this"],
                    "type": "RESPONSE_HEADERS",
                },
                {
                    "conditions": [{
                        "lhs": "SIZE",
                        "op": "GE",
                        "rhs": "1000",
                    }],
                    "type": "RESPONSE_BODY",
                },
            ],
            severity="CRITICAL",
            type="RESPONSE")
        ```

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        :param str resource_name: The name of the resource.
        :param InspectionCustomControlsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InspectionCustomControlsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 control_type: Optional[pulumi.Input[builtins.str]] = None,
                 default_action: Optional[pulumi.Input[builtins.str]] = None,
                 default_action_value: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 paranoia_level: Optional[pulumi.Input[builtins.str]] = None,
                 protocol_type: Optional[pulumi.Input[builtins.str]] = None,
                 rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['InspectionCustomControlsRuleArgs', 'InspectionCustomControlsRuleArgsDict']]]]] = None,
                 severity: Optional[pulumi.Input[builtins.str]] = None,
                 type: Optional[pulumi.Input[builtins.str]] = None,
                 version: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InspectionCustomControlsArgs.__new__(InspectionCustomControlsArgs)

            __props__.__dict__["control_type"] = control_type
            __props__.__dict__["default_action"] = default_action
            __props__.__dict__["default_action_value"] = default_action_value
            __props__.__dict__["description"] = description
            __props__.__dict__["name"] = name
            __props__.__dict__["paranoia_level"] = paranoia_level
            __props__.__dict__["protocol_type"] = protocol_type
            __props__.__dict__["rules"] = rules
            if severity is None and not opts.urn:
                raise TypeError("Missing required property 'severity'")
            __props__.__dict__["severity"] = severity
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["version"] = version
        super(InspectionCustomControls, __self__).__init__(
            'zpa:index/inspectionCustomControls:InspectionCustomControls',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            control_type: Optional[pulumi.Input[builtins.str]] = None,
            default_action: Optional[pulumi.Input[builtins.str]] = None,
            default_action_value: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            paranoia_level: Optional[pulumi.Input[builtins.str]] = None,
            protocol_type: Optional[pulumi.Input[builtins.str]] = None,
            rules: Optional[pulumi.Input[Sequence[pulumi.Input[Union['InspectionCustomControlsRuleArgs', 'InspectionCustomControlsRuleArgsDict']]]]] = None,
            severity: Optional[pulumi.Input[builtins.str]] = None,
            type: Optional[pulumi.Input[builtins.str]] = None,
            version: Optional[pulumi.Input[builtins.str]] = None) -> 'InspectionCustomControls':
        """
        Get an existing InspectionCustomControls resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] default_action: The performed action
        :param pulumi.Input[builtins.str] default_action_value: This is used to provide the redirect URL if the default action is set to REDIRECT
        :param pulumi.Input[builtins.str] description: Description of the custom control
        :param pulumi.Input[builtins.str] paranoia_level: OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        :param pulumi.Input[Sequence[pulumi.Input[Union['InspectionCustomControlsRuleArgs', 'InspectionCustomControlsRuleArgsDict']]]] rules: Rules of the custom controls applied as conditions (JSON)
        :param pulumi.Input[builtins.str] severity: Severity of the control number
        :param pulumi.Input[builtins.str] type: Rules to be applied to the request or response type
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InspectionCustomControlsState.__new__(_InspectionCustomControlsState)

        __props__.__dict__["control_type"] = control_type
        __props__.__dict__["default_action"] = default_action
        __props__.__dict__["default_action_value"] = default_action_value
        __props__.__dict__["description"] = description
        __props__.__dict__["name"] = name
        __props__.__dict__["paranoia_level"] = paranoia_level
        __props__.__dict__["protocol_type"] = protocol_type
        __props__.__dict__["rules"] = rules
        __props__.__dict__["severity"] = severity
        __props__.__dict__["type"] = type
        __props__.__dict__["version"] = version
        return InspectionCustomControls(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="controlType")
    def control_type(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "control_type")

    @property
    @pulumi.getter(name="defaultAction")
    def default_action(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The performed action
        """
        return pulumi.get(self, "default_action")

    @property
    @pulumi.getter(name="defaultActionValue")
    def default_action_value(self) -> pulumi.Output[builtins.str]:
        """
        This is used to provide the redirect URL if the default action is set to REDIRECT
        """
        return pulumi.get(self, "default_action_value")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[builtins.str]:
        """
        Description of the custom control
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="paranoiaLevel")
    def paranoia_level(self) -> pulumi.Output[builtins.str]:
        """
        OWASP Predefined Paranoia Level. Range: [1-4], inclusive
        """
        return pulumi.get(self, "paranoia_level")

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "protocol_type")

    @property
    @pulumi.getter
    def rules(self) -> pulumi.Output[Sequence['outputs.InspectionCustomControlsRule']]:
        """
        Rules of the custom controls applied as conditions (JSON)
        """
        return pulumi.get(self, "rules")

    @property
    @pulumi.getter
    def severity(self) -> pulumi.Output[builtins.str]:
        """
        Severity of the control number
        """
        return pulumi.get(self, "severity")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[builtins.str]:
        """
        Rules to be applied to the request or response type
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def version(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "version")

