# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['PRAPortalArgs', 'PRAPortal']

@pulumi.input_type
class PRAPortalArgs:
    def __init__(__self__, *,
                 certificate_id: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 ext_domain: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_name: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_translation: Optional[pulumi.Input[builtins.str]] = None,
                 ext_label: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 user_portal_gid: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a PRAPortal resource.
        :param pulumi.Input[builtins.str] certificate_id: The unique identifier of the certificate
        :param pulumi.Input[builtins.str] description: The description of the privileged portal
        :param pulumi.Input[builtins.str] domain: The domain of the privileged portal
        :param pulumi.Input[builtins.bool] enabled: Whether or not the privileged portal is enabled
        :param pulumi.Input[builtins.str] ext_domain: The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
               creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_domain_name: The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        :param pulumi.Input[builtins.str] ext_domain_translation: The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
               certificates when creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_label: The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
               only supports a hyphen (-).
        :param pulumi.Input[builtins.str] microtenant_id: The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
               microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
               retrieve data from all customers associated with the tenant.
        :param pulumi.Input[builtins.str] name: The name of the privileged portal
        :param pulumi.Input[builtins.str] user_notification: The notification message displayed in the banner of the privileged portallink, if enabled
        :param pulumi.Input[builtins.bool] user_notification_enabled: Indicates if the Notification Banner is enabled (true) or disabled (false)
        :param pulumi.Input[builtins.str] user_portal_gid: The unique identifier of the user portal.
        """
        if certificate_id is not None:
            pulumi.set(__self__, "certificate_id", certificate_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if ext_domain is not None:
            pulumi.set(__self__, "ext_domain", ext_domain)
        if ext_domain_name is not None:
            pulumi.set(__self__, "ext_domain_name", ext_domain_name)
        if ext_domain_translation is not None:
            pulumi.set(__self__, "ext_domain_translation", ext_domain_translation)
        if ext_label is not None:
            pulumi.set(__self__, "ext_label", ext_label)
        if microtenant_id is not None:
            pulumi.set(__self__, "microtenant_id", microtenant_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if user_notification is not None:
            pulumi.set(__self__, "user_notification", user_notification)
        if user_notification_enabled is not None:
            pulumi.set(__self__, "user_notification_enabled", user_notification_enabled)
        if user_portal_gid is not None:
            pulumi.set(__self__, "user_portal_gid", user_portal_gid)

    @property
    @pulumi.getter(name="certificateId")
    def certificate_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the certificate
        """
        return pulumi.get(self, "certificate_id")

    @certificate_id.setter
    def certificate_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "certificate_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The description of the privileged portal
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The domain of the privileged portal
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether or not the privileged portal is enabled
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="extDomain")
    def ext_domain(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
        creating a privileged portal.
        """
        return pulumi.get(self, "ext_domain")

    @ext_domain.setter
    def ext_domain(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_domain", value)

    @property
    @pulumi.getter(name="extDomainName")
    def ext_domain_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        """
        return pulumi.get(self, "ext_domain_name")

    @ext_domain_name.setter
    def ext_domain_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_domain_name", value)

    @property
    @pulumi.getter(name="extDomainTranslation")
    def ext_domain_translation(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
        certificates when creating a privileged portal.
        """
        return pulumi.get(self, "ext_domain_translation")

    @ext_domain_translation.setter
    def ext_domain_translation(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_domain_translation", value)

    @property
    @pulumi.getter(name="extLabel")
    def ext_label(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
        only supports a hyphen (-).
        """
        return pulumi.get(self, "ext_label")

    @ext_label.setter
    def ext_label(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_label", value)

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
        microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
        retrieve data from all customers associated with the tenant.
        """
        return pulumi.get(self, "microtenant_id")

    @microtenant_id.setter
    def microtenant_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "microtenant_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the privileged portal
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="userNotification")
    def user_notification(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The notification message displayed in the banner of the privileged portallink, if enabled
        """
        return pulumi.get(self, "user_notification")

    @user_notification.setter
    def user_notification(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_notification", value)

    @property
    @pulumi.getter(name="userNotificationEnabled")
    def user_notification_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Indicates if the Notification Banner is enabled (true) or disabled (false)
        """
        return pulumi.get(self, "user_notification_enabled")

    @user_notification_enabled.setter
    def user_notification_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "user_notification_enabled", value)

    @property
    @pulumi.getter(name="userPortalGid")
    def user_portal_gid(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the user portal.
        """
        return pulumi.get(self, "user_portal_gid")

    @user_portal_gid.setter
    def user_portal_gid(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_portal_gid", value)


@pulumi.input_type
class _PRAPortalState:
    def __init__(__self__, *,
                 certificate_id: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 ext_domain: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_name: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_translation: Optional[pulumi.Input[builtins.str]] = None,
                 ext_label: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 user_portal_gid: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering PRAPortal resources.
        :param pulumi.Input[builtins.str] certificate_id: The unique identifier of the certificate
        :param pulumi.Input[builtins.str] description: The description of the privileged portal
        :param pulumi.Input[builtins.str] domain: The domain of the privileged portal
        :param pulumi.Input[builtins.bool] enabled: Whether or not the privileged portal is enabled
        :param pulumi.Input[builtins.str] ext_domain: The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
               creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_domain_name: The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        :param pulumi.Input[builtins.str] ext_domain_translation: The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
               certificates when creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_label: The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
               only supports a hyphen (-).
        :param pulumi.Input[builtins.str] microtenant_id: The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
               microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
               retrieve data from all customers associated with the tenant.
        :param pulumi.Input[builtins.str] name: The name of the privileged portal
        :param pulumi.Input[builtins.str] user_notification: The notification message displayed in the banner of the privileged portallink, if enabled
        :param pulumi.Input[builtins.bool] user_notification_enabled: Indicates if the Notification Banner is enabled (true) or disabled (false)
        :param pulumi.Input[builtins.str] user_portal_gid: The unique identifier of the user portal.
        """
        if certificate_id is not None:
            pulumi.set(__self__, "certificate_id", certificate_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if ext_domain is not None:
            pulumi.set(__self__, "ext_domain", ext_domain)
        if ext_domain_name is not None:
            pulumi.set(__self__, "ext_domain_name", ext_domain_name)
        if ext_domain_translation is not None:
            pulumi.set(__self__, "ext_domain_translation", ext_domain_translation)
        if ext_label is not None:
            pulumi.set(__self__, "ext_label", ext_label)
        if microtenant_id is not None:
            pulumi.set(__self__, "microtenant_id", microtenant_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if user_notification is not None:
            pulumi.set(__self__, "user_notification", user_notification)
        if user_notification_enabled is not None:
            pulumi.set(__self__, "user_notification_enabled", user_notification_enabled)
        if user_portal_gid is not None:
            pulumi.set(__self__, "user_portal_gid", user_portal_gid)

    @property
    @pulumi.getter(name="certificateId")
    def certificate_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the certificate
        """
        return pulumi.get(self, "certificate_id")

    @certificate_id.setter
    def certificate_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "certificate_id", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The description of the privileged portal
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The domain of the privileged portal
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether or not the privileged portal is enabled
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="extDomain")
    def ext_domain(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
        creating a privileged portal.
        """
        return pulumi.get(self, "ext_domain")

    @ext_domain.setter
    def ext_domain(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_domain", value)

    @property
    @pulumi.getter(name="extDomainName")
    def ext_domain_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        """
        return pulumi.get(self, "ext_domain_name")

    @ext_domain_name.setter
    def ext_domain_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_domain_name", value)

    @property
    @pulumi.getter(name="extDomainTranslation")
    def ext_domain_translation(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
        certificates when creating a privileged portal.
        """
        return pulumi.get(self, "ext_domain_translation")

    @ext_domain_translation.setter
    def ext_domain_translation(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_domain_translation", value)

    @property
    @pulumi.getter(name="extLabel")
    def ext_label(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
        only supports a hyphen (-).
        """
        return pulumi.get(self, "ext_label")

    @ext_label.setter
    def ext_label(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "ext_label", value)

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
        microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
        retrieve data from all customers associated with the tenant.
        """
        return pulumi.get(self, "microtenant_id")

    @microtenant_id.setter
    def microtenant_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "microtenant_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The name of the privileged portal
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="userNotification")
    def user_notification(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The notification message displayed in the banner of the privileged portallink, if enabled
        """
        return pulumi.get(self, "user_notification")

    @user_notification.setter
    def user_notification(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_notification", value)

    @property
    @pulumi.getter(name="userNotificationEnabled")
    def user_notification_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Indicates if the Notification Banner is enabled (true) or disabled (false)
        """
        return pulumi.get(self, "user_notification_enabled")

    @user_notification_enabled.setter
    def user_notification_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "user_notification_enabled", value)

    @property
    @pulumi.getter(name="userPortalGid")
    def user_portal_gid(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The unique identifier of the user portal.
        """
        return pulumi.get(self, "user_portal_gid")

    @user_portal_gid.setter
    def user_portal_gid(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "user_portal_gid", value)


@pulumi.type_token("zpa:index/pRAPortal:PRAPortal")
class PRAPortal(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 certificate_id: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 ext_domain: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_name: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_translation: Optional[pulumi.Input[builtins.str]] = None,
                 ext_label: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 user_portal_gid: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-privileged-portals)
        * [API documentation](https://help.zscaler.com/zpa/configuring-privileged-portals-using-api)

        The **zpa_pra_portal_controller** resource creates a privileged remote access portal in the Zscaler Private Access cloud. This resource can then be referenced in an privileged remote access console resource.

        ## Example Usage

        ### Using Custom Certificate

        ```python
        import pulumi
        import pulumi_zpa as zpa
        import zscaler_pulumi_zpa as zpa

        this_ba_certificate = zpa.get_ba_certificate(name="portal.acme.com")
        this_pra_portal = zpa.PRAPortal("thisPRAPortal",
            description="portal.acme.com",
            enabled=True,
            domain="portal.acme.com",
            certificate_id=this_ba_certificate.id,
            user_notification="Created with Terraform",
            user_notification_enabled=True)
        ```

        ### Zscaler Managed Certificate

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.PRAPortal("this",
            description="server1.acme.com",
            domain="server1-acme.com.pra.d.zscalerportal.net",
            enabled=True,
            ext_domain="acme.com",
            ext_domain_name="acme.com.pra.d.zscalerportal.net",
            ext_domain_translation="acme.com",
            ext_label="server1",
            user_notification="Created with Terraform",
            user_notification_enabled=True)
        ```

        # Configuring PRA Portal with User Portal
        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.PRAPortal("this",
            description="Server1 PRA01 Description",
            domain="server1-acme.com.pra.d.zscalerportal.net",
            enabled=True,
            ext_domain="acme.com",
            ext_domain_name="acme.com.pra.d.zscalerportal.net",
            ext_domain_translation="acme.com",
            ext_label="server1",
            user_notification="Created with Terraform",
            user_notification_enabled=True,
            user_portal_gid="145262059234265326")
        ```

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **pra_portal_controller** can be imported by using `<PORTAL ID>` or `<PORTAL NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zpa:index/pRAPortal:PRAPortal this <portal_id>
        ```

        or

        ```sh
        $ pulumi import zpa:index/pRAPortal:PRAPortal this <portal_name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] certificate_id: The unique identifier of the certificate
        :param pulumi.Input[builtins.str] description: The description of the privileged portal
        :param pulumi.Input[builtins.str] domain: The domain of the privileged portal
        :param pulumi.Input[builtins.bool] enabled: Whether or not the privileged portal is enabled
        :param pulumi.Input[builtins.str] ext_domain: The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
               creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_domain_name: The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        :param pulumi.Input[builtins.str] ext_domain_translation: The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
               certificates when creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_label: The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
               only supports a hyphen (-).
        :param pulumi.Input[builtins.str] microtenant_id: The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
               microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
               retrieve data from all customers associated with the tenant.
        :param pulumi.Input[builtins.str] name: The name of the privileged portal
        :param pulumi.Input[builtins.str] user_notification: The notification message displayed in the banner of the privileged portallink, if enabled
        :param pulumi.Input[builtins.bool] user_notification_enabled: Indicates if the Notification Banner is enabled (true) or disabled (false)
        :param pulumi.Input[builtins.str] user_portal_gid: The unique identifier of the user portal.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[PRAPortalArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-privileged-portals)
        * [API documentation](https://help.zscaler.com/zpa/configuring-privileged-portals-using-api)

        The **zpa_pra_portal_controller** resource creates a privileged remote access portal in the Zscaler Private Access cloud. This resource can then be referenced in an privileged remote access console resource.

        ## Example Usage

        ### Using Custom Certificate

        ```python
        import pulumi
        import pulumi_zpa as zpa
        import zscaler_pulumi_zpa as zpa

        this_ba_certificate = zpa.get_ba_certificate(name="portal.acme.com")
        this_pra_portal = zpa.PRAPortal("thisPRAPortal",
            description="portal.acme.com",
            enabled=True,
            domain="portal.acme.com",
            certificate_id=this_ba_certificate.id,
            user_notification="Created with Terraform",
            user_notification_enabled=True)
        ```

        ### Zscaler Managed Certificate

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.PRAPortal("this",
            description="server1.acme.com",
            domain="server1-acme.com.pra.d.zscalerportal.net",
            enabled=True,
            ext_domain="acme.com",
            ext_domain_name="acme.com.pra.d.zscalerportal.net",
            ext_domain_translation="acme.com",
            ext_label="server1",
            user_notification="Created with Terraform",
            user_notification_enabled=True)
        ```

        # Configuring PRA Portal with User Portal
        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        this = zpa.PRAPortal("this",
            description="Server1 PRA01 Description",
            domain="server1-acme.com.pra.d.zscalerportal.net",
            enabled=True,
            ext_domain="acme.com",
            ext_domain_name="acme.com.pra.d.zscalerportal.net",
            ext_domain_translation="acme.com",
            ext_label="server1",
            user_notification="Created with Terraform",
            user_notification_enabled=True,
            user_portal_gid="145262059234265326")
        ```

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        **pra_portal_controller** can be imported by using `<PORTAL ID>` or `<PORTAL NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zpa:index/pRAPortal:PRAPortal this <portal_id>
        ```

        or

        ```sh
        $ pulumi import zpa:index/pRAPortal:PRAPortal this <portal_name>
        ```

        :param str resource_name: The name of the resource.
        :param PRAPortalArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PRAPortalArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 certificate_id: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 domain: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 ext_domain: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_name: Optional[pulumi.Input[builtins.str]] = None,
                 ext_domain_translation: Optional[pulumi.Input[builtins.str]] = None,
                 ext_label: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification: Optional[pulumi.Input[builtins.str]] = None,
                 user_notification_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 user_portal_gid: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PRAPortalArgs.__new__(PRAPortalArgs)

            __props__.__dict__["certificate_id"] = certificate_id
            __props__.__dict__["description"] = description
            __props__.__dict__["domain"] = domain
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["ext_domain"] = ext_domain
            __props__.__dict__["ext_domain_name"] = ext_domain_name
            __props__.__dict__["ext_domain_translation"] = ext_domain_translation
            __props__.__dict__["ext_label"] = ext_label
            __props__.__dict__["microtenant_id"] = microtenant_id
            __props__.__dict__["name"] = name
            __props__.__dict__["user_notification"] = user_notification
            __props__.__dict__["user_notification_enabled"] = user_notification_enabled
            __props__.__dict__["user_portal_gid"] = user_portal_gid
        alias_opts = pulumi.ResourceOptions(aliases=[pulumi.Alias(type_="zpa:index/praPortalController:PraPortalController")])
        opts = pulumi.ResourceOptions.merge(opts, alias_opts)
        super(PRAPortal, __self__).__init__(
            'zpa:index/pRAPortal:PRAPortal',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            certificate_id: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            domain: Optional[pulumi.Input[builtins.str]] = None,
            enabled: Optional[pulumi.Input[builtins.bool]] = None,
            ext_domain: Optional[pulumi.Input[builtins.str]] = None,
            ext_domain_name: Optional[pulumi.Input[builtins.str]] = None,
            ext_domain_translation: Optional[pulumi.Input[builtins.str]] = None,
            ext_label: Optional[pulumi.Input[builtins.str]] = None,
            microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            user_notification: Optional[pulumi.Input[builtins.str]] = None,
            user_notification_enabled: Optional[pulumi.Input[builtins.bool]] = None,
            user_portal_gid: Optional[pulumi.Input[builtins.str]] = None) -> 'PRAPortal':
        """
        Get an existing PRAPortal resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] certificate_id: The unique identifier of the certificate
        :param pulumi.Input[builtins.str] description: The description of the privileged portal
        :param pulumi.Input[builtins.str] domain: The domain of the privileged portal
        :param pulumi.Input[builtins.bool] enabled: Whether or not the privileged portal is enabled
        :param pulumi.Input[builtins.str] ext_domain: The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
               creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_domain_name: The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        :param pulumi.Input[builtins.str] ext_domain_translation: The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
               certificates when creating a privileged portal.
        :param pulumi.Input[builtins.str] ext_label: The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
               only supports a hyphen (-).
        :param pulumi.Input[builtins.str] microtenant_id: The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
               microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
               retrieve data from all customers associated with the tenant.
        :param pulumi.Input[builtins.str] name: The name of the privileged portal
        :param pulumi.Input[builtins.str] user_notification: The notification message displayed in the banner of the privileged portallink, if enabled
        :param pulumi.Input[builtins.bool] user_notification_enabled: Indicates if the Notification Banner is enabled (true) or disabled (false)
        :param pulumi.Input[builtins.str] user_portal_gid: The unique identifier of the user portal.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PRAPortalState.__new__(_PRAPortalState)

        __props__.__dict__["certificate_id"] = certificate_id
        __props__.__dict__["description"] = description
        __props__.__dict__["domain"] = domain
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["ext_domain"] = ext_domain
        __props__.__dict__["ext_domain_name"] = ext_domain_name
        __props__.__dict__["ext_domain_translation"] = ext_domain_translation
        __props__.__dict__["ext_label"] = ext_label
        __props__.__dict__["microtenant_id"] = microtenant_id
        __props__.__dict__["name"] = name
        __props__.__dict__["user_notification"] = user_notification
        __props__.__dict__["user_notification_enabled"] = user_notification_enabled
        __props__.__dict__["user_portal_gid"] = user_portal_gid
        return PRAPortal(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="certificateId")
    def certificate_id(self) -> pulumi.Output[builtins.str]:
        """
        The unique identifier of the certificate
        """
        return pulumi.get(self, "certificate_id")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The description of the privileged portal
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The domain of the privileged portal
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether or not the privileged portal is enabled
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="extDomain")
    def ext_domain(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The external domain name prefix of the Browser Access application that is used for Zscaler-managed certificates when
        creating a privileged portal.
        """
        return pulumi.get(self, "ext_domain")

    @property
    @pulumi.getter(name="extDomainName")
    def ext_domain_name(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The domain suffix for the privileged portal URL. This field must be one of the customer's authentication domains.
        """
        return pulumi.get(self, "ext_domain_name")

    @property
    @pulumi.getter(name="extDomainTranslation")
    def ext_domain_translation(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The translation of the external domain name prefix of the Browser Access application that is used for Zscaler-managed
        certificates when creating a privileged portal.
        """
        return pulumi.get(self, "ext_domain_translation")

    @property
    @pulumi.getter(name="extLabel")
    def ext_label(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The domain prefix for the privileged portal URL. The supported string can include numbers, lower case characters, and
        only supports a hyphen (-).
        """
        return pulumi.get(self, "ext_label")

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The unique identifier of the Microtenant for the ZPA tenant. If you are within the Default Microtenant, pass
        microtenantId as 0 when making requests to retrieve data from the Default Microtenant. Pass microtenantId as null to
        retrieve data from all customers associated with the tenant.
        """
        return pulumi.get(self, "microtenant_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        The name of the privileged portal
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="userNotification")
    def user_notification(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The notification message displayed in the banner of the privileged portallink, if enabled
        """
        return pulumi.get(self, "user_notification")

    @property
    @pulumi.getter(name="userNotificationEnabled")
    def user_notification_enabled(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Indicates if the Notification Banner is enabled (true) or disabled (false)
        """
        return pulumi.get(self, "user_notification_enabled")

    @property
    @pulumi.getter(name="userPortalGid")
    def user_portal_gid(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        The unique identifier of the user portal.
        """
        return pulumi.get(self, "user_portal_gid")

