# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ServiceEdgeGroupArgs', 'ServiceEdgeGroup']

@pulumi.input_type
class ServiceEdgeGroupArgs:
    def __init__(__self__, *,
                 latitude: pulumi.Input[builtins.str],
                 location: pulumi.Input[builtins.str],
                 longitude: pulumi.Input[builtins.str],
                 city_country: Optional[pulumi.Input[builtins.str]] = None,
                 country_code: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_value: Optional[pulumi.Input[builtins.str]] = None,
                 grace_distance_value_unit: Optional[pulumi.Input[builtins.str]] = None,
                 is_public: Optional[pulumi.Input[builtins.bool]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 override_version_profile: Optional[pulumi.Input[builtins.bool]] = None,
                 service_edges: Optional[pulumi.Input['ServiceEdgeGroupServiceEdgesArgs']] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]] = None,
                 upgrade_day: Optional[pulumi.Input[builtins.str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[builtins.str]] = None,
                 use_in_dr_mode: Optional[pulumi.Input[builtins.bool]] = None,
                 version_profile_id: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_visibility_scope: Optional[pulumi.Input[builtins.str]] = None):
        """
        The set of arguments for constructing a ServiceEdgeGroup resource.
        :param pulumi.Input[builtins.str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] location: Location for the Service Edge Group.
        :param pulumi.Input[builtins.str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] description: Description of the Service Edge Group.
        :param pulumi.Input[builtins.bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[builtins.bool] grace_distance_enabled: If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
               Public Service Edge.
        :param pulumi.Input[builtins.str] grace_distance_value: Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
               Public Service Edge
        :param pulumi.Input[builtins.str] grace_distance_value_unit: Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
               is set to true
        :param pulumi.Input[builtins.bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[builtins.str] name: Name of the Service Edge Group.
        :param pulumi.Input[builtins.bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input['ServiceEdgeGroupServiceEdgesArgs'] service_edges: WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
               matching.This field will be deprecated in future versions
        :param pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[builtins.str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[builtins.str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[builtins.str] version_profile_id: ID of the version profile.
        :param pulumi.Input[builtins.str] version_profile_name: Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
               overrideVersionProfile is set to true
        :param pulumi.Input[builtins.str] version_profile_visibility_scope: ID of the version profile.
        """
        pulumi.set(__self__, "latitude", latitude)
        pulumi.set(__self__, "location", location)
        pulumi.set(__self__, "longitude", longitude)
        if city_country is not None:
            pulumi.set(__self__, "city_country", city_country)
        if country_code is not None:
            pulumi.set(__self__, "country_code", country_code)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if grace_distance_enabled is not None:
            pulumi.set(__self__, "grace_distance_enabled", grace_distance_enabled)
        if grace_distance_value is not None:
            pulumi.set(__self__, "grace_distance_value", grace_distance_value)
        if grace_distance_value_unit is not None:
            pulumi.set(__self__, "grace_distance_value_unit", grace_distance_value_unit)
        if is_public is not None:
            pulumi.set(__self__, "is_public", is_public)
        if microtenant_id is not None:
            pulumi.set(__self__, "microtenant_id", microtenant_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if override_version_profile is not None:
            pulumi.set(__self__, "override_version_profile", override_version_profile)
        if service_edges is not None:
            pulumi.set(__self__, "service_edges", service_edges)
        if trusted_networks is not None:
            pulumi.set(__self__, "trusted_networks", trusted_networks)
        if upgrade_day is not None:
            pulumi.set(__self__, "upgrade_day", upgrade_day)
        if upgrade_time_in_secs is not None:
            pulumi.set(__self__, "upgrade_time_in_secs", upgrade_time_in_secs)
        if use_in_dr_mode is not None:
            pulumi.set(__self__, "use_in_dr_mode", use_in_dr_mode)
        if version_profile_id is not None:
            pulumi.set(__self__, "version_profile_id", version_profile_id)
        if version_profile_name is not None:
            pulumi.set(__self__, "version_profile_name", version_profile_name)
        if version_profile_visibility_scope is not None:
            pulumi.set(__self__, "version_profile_visibility_scope", version_profile_visibility_scope)

    @property
    @pulumi.getter
    def latitude(self) -> pulumi.Input[builtins.str]:
        """
        Latitude for the Service Edge Group.
        """
        return pulumi.get(self, "latitude")

    @latitude.setter
    def latitude(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "latitude", value)

    @property
    @pulumi.getter
    def location(self) -> pulumi.Input[builtins.str]:
        """
        Location for the Service Edge Group.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def longitude(self) -> pulumi.Input[builtins.str]:
        """
        Longitude for the Service Edge Group.
        """
        return pulumi.get(self, "longitude")

    @longitude.setter
    def longitude(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "longitude", value)

    @property
    @pulumi.getter(name="cityCountry")
    def city_country(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "city_country")

    @city_country.setter
    def city_country(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "city_country", value)

    @property
    @pulumi.getter(name="countryCode")
    def country_code(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "country_code")

    @country_code.setter
    def country_code(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "country_code", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Description of the Service Edge Group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether this Service Edge Group is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="graceDistanceEnabled")
    def grace_distance_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
        Public Service Edge.
        """
        return pulumi.get(self, "grace_distance_enabled")

    @grace_distance_enabled.setter
    def grace_distance_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "grace_distance_enabled", value)

    @property
    @pulumi.getter(name="graceDistanceValue")
    def grace_distance_value(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
        Public Service Edge
        """
        return pulumi.get(self, "grace_distance_value")

    @grace_distance_value.setter
    def grace_distance_value(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "grace_distance_value", value)

    @property
    @pulumi.getter(name="graceDistanceValueUnit")
    def grace_distance_value_unit(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
        is set to true
        """
        return pulumi.get(self, "grace_distance_value_unit")

    @grace_distance_value_unit.setter
    def grace_distance_value_unit(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "grace_distance_value_unit", value)

    @property
    @pulumi.getter(name="isPublic")
    def is_public(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enable or disable public access for the Service Edge Group.
        """
        return pulumi.get(self, "is_public")

    @is_public.setter
    def is_public(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_public", value)

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "microtenant_id")

    @microtenant_id.setter
    def microtenant_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "microtenant_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the Service Edge Group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="overrideVersionProfile")
    def override_version_profile(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the default version profile of the App Connector Group is applied or overridden.
        """
        return pulumi.get(self, "override_version_profile")

    @override_version_profile.setter
    def override_version_profile(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "override_version_profile", value)

    @property
    @pulumi.getter(name="serviceEdges")
    def service_edges(self) -> Optional[pulumi.Input['ServiceEdgeGroupServiceEdgesArgs']]:
        """
        WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
        matching.This field will be deprecated in future versions
        """
        return pulumi.get(self, "service_edges")

    @service_edges.setter
    def service_edges(self, value: Optional[pulumi.Input['ServiceEdgeGroupServiceEdgesArgs']]):
        pulumi.set(self, "service_edges", value)

    @property
    @pulumi.getter(name="trustedNetworks")
    def trusted_networks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]:
        """
        List of trusted network IDs.
        """
        return pulumi.get(self, "trusted_networks")

    @trusted_networks.setter
    def trusted_networks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]):
        pulumi.set(self, "trusted_networks", value)

    @property
    @pulumi.getter(name="upgradeDay")
    def upgrade_day(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        """
        return pulumi.get(self, "upgrade_day")

    @upgrade_day.setter
    def upgrade_day(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "upgrade_day", value)

    @property
    @pulumi.getter(name="upgradeTimeInSecs")
    def upgrade_time_in_secs(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        """
        return pulumi.get(self, "upgrade_time_in_secs")

    @upgrade_time_in_secs.setter
    def upgrade_time_in_secs(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "upgrade_time_in_secs", value)

    @property
    @pulumi.getter(name="useInDrMode")
    def use_in_dr_mode(self) -> Optional[pulumi.Input[builtins.bool]]:
        return pulumi.get(self, "use_in_dr_mode")

    @use_in_dr_mode.setter
    def use_in_dr_mode(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "use_in_dr_mode", value)

    @property
    @pulumi.getter(name="versionProfileId")
    def version_profile_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_id")

    @version_profile_id.setter
    def version_profile_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version_profile_id", value)

    @property
    @pulumi.getter(name="versionProfileName")
    def version_profile_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
        overrideVersionProfile is set to true
        """
        return pulumi.get(self, "version_profile_name")

    @version_profile_name.setter
    def version_profile_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version_profile_name", value)

    @property
    @pulumi.getter(name="versionProfileVisibilityScope")
    def version_profile_visibility_scope(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_visibility_scope")

    @version_profile_visibility_scope.setter
    def version_profile_visibility_scope(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version_profile_visibility_scope", value)


@pulumi.input_type
class _ServiceEdgeGroupState:
    def __init__(__self__, *,
                 city_country: Optional[pulumi.Input[builtins.str]] = None,
                 country_code: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_value: Optional[pulumi.Input[builtins.str]] = None,
                 grace_distance_value_unit: Optional[pulumi.Input[builtins.str]] = None,
                 is_public: Optional[pulumi.Input[builtins.bool]] = None,
                 latitude: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 longitude: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 override_version_profile: Optional[pulumi.Input[builtins.bool]] = None,
                 service_edges: Optional[pulumi.Input['ServiceEdgeGroupServiceEdgesArgs']] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]] = None,
                 upgrade_day: Optional[pulumi.Input[builtins.str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[builtins.str]] = None,
                 use_in_dr_mode: Optional[pulumi.Input[builtins.bool]] = None,
                 version_profile_id: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_visibility_scope: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering ServiceEdgeGroup resources.
        :param pulumi.Input[builtins.str] description: Description of the Service Edge Group.
        :param pulumi.Input[builtins.bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[builtins.bool] grace_distance_enabled: If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
               Public Service Edge.
        :param pulumi.Input[builtins.str] grace_distance_value: Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
               Public Service Edge
        :param pulumi.Input[builtins.str] grace_distance_value_unit: Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
               is set to true
        :param pulumi.Input[builtins.bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[builtins.str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] location: Location for the Service Edge Group.
        :param pulumi.Input[builtins.str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] name: Name of the Service Edge Group.
        :param pulumi.Input[builtins.bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input['ServiceEdgeGroupServiceEdgesArgs'] service_edges: WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
               matching.This field will be deprecated in future versions
        :param pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[builtins.str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[builtins.str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[builtins.str] version_profile_id: ID of the version profile.
        :param pulumi.Input[builtins.str] version_profile_name: Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
               overrideVersionProfile is set to true
        :param pulumi.Input[builtins.str] version_profile_visibility_scope: ID of the version profile.
        """
        if city_country is not None:
            pulumi.set(__self__, "city_country", city_country)
        if country_code is not None:
            pulumi.set(__self__, "country_code", country_code)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if enabled is not None:
            pulumi.set(__self__, "enabled", enabled)
        if grace_distance_enabled is not None:
            pulumi.set(__self__, "grace_distance_enabled", grace_distance_enabled)
        if grace_distance_value is not None:
            pulumi.set(__self__, "grace_distance_value", grace_distance_value)
        if grace_distance_value_unit is not None:
            pulumi.set(__self__, "grace_distance_value_unit", grace_distance_value_unit)
        if is_public is not None:
            pulumi.set(__self__, "is_public", is_public)
        if latitude is not None:
            pulumi.set(__self__, "latitude", latitude)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if longitude is not None:
            pulumi.set(__self__, "longitude", longitude)
        if microtenant_id is not None:
            pulumi.set(__self__, "microtenant_id", microtenant_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if override_version_profile is not None:
            pulumi.set(__self__, "override_version_profile", override_version_profile)
        if service_edges is not None:
            pulumi.set(__self__, "service_edges", service_edges)
        if trusted_networks is not None:
            pulumi.set(__self__, "trusted_networks", trusted_networks)
        if upgrade_day is not None:
            pulumi.set(__self__, "upgrade_day", upgrade_day)
        if upgrade_time_in_secs is not None:
            pulumi.set(__self__, "upgrade_time_in_secs", upgrade_time_in_secs)
        if use_in_dr_mode is not None:
            pulumi.set(__self__, "use_in_dr_mode", use_in_dr_mode)
        if version_profile_id is not None:
            pulumi.set(__self__, "version_profile_id", version_profile_id)
        if version_profile_name is not None:
            pulumi.set(__self__, "version_profile_name", version_profile_name)
        if version_profile_visibility_scope is not None:
            pulumi.set(__self__, "version_profile_visibility_scope", version_profile_visibility_scope)

    @property
    @pulumi.getter(name="cityCountry")
    def city_country(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "city_country")

    @city_country.setter
    def city_country(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "city_country", value)

    @property
    @pulumi.getter(name="countryCode")
    def country_code(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "country_code")

    @country_code.setter
    def country_code(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "country_code", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Description of the Service Edge Group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether this Service Edge Group is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @enabled.setter
    def enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "enabled", value)

    @property
    @pulumi.getter(name="graceDistanceEnabled")
    def grace_distance_enabled(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
        Public Service Edge.
        """
        return pulumi.get(self, "grace_distance_enabled")

    @grace_distance_enabled.setter
    def grace_distance_enabled(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "grace_distance_enabled", value)

    @property
    @pulumi.getter(name="graceDistanceValue")
    def grace_distance_value(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
        Public Service Edge
        """
        return pulumi.get(self, "grace_distance_value")

    @grace_distance_value.setter
    def grace_distance_value(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "grace_distance_value", value)

    @property
    @pulumi.getter(name="graceDistanceValueUnit")
    def grace_distance_value_unit(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
        is set to true
        """
        return pulumi.get(self, "grace_distance_value_unit")

    @grace_distance_value_unit.setter
    def grace_distance_value_unit(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "grace_distance_value_unit", value)

    @property
    @pulumi.getter(name="isPublic")
    def is_public(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Enable or disable public access for the Service Edge Group.
        """
        return pulumi.get(self, "is_public")

    @is_public.setter
    def is_public(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "is_public", value)

    @property
    @pulumi.getter
    def latitude(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Latitude for the Service Edge Group.
        """
        return pulumi.get(self, "latitude")

    @latitude.setter
    def latitude(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "latitude", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Location for the Service Edge Group.
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def longitude(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Longitude for the Service Edge Group.
        """
        return pulumi.get(self, "longitude")

    @longitude.setter
    def longitude(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "longitude", value)

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> Optional[pulumi.Input[builtins.str]]:
        return pulumi.get(self, "microtenant_id")

    @microtenant_id.setter
    def microtenant_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "microtenant_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the Service Edge Group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="overrideVersionProfile")
    def override_version_profile(self) -> Optional[pulumi.Input[builtins.bool]]:
        """
        Whether the default version profile of the App Connector Group is applied or overridden.
        """
        return pulumi.get(self, "override_version_profile")

    @override_version_profile.setter
    def override_version_profile(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "override_version_profile", value)

    @property
    @pulumi.getter(name="serviceEdges")
    def service_edges(self) -> Optional[pulumi.Input['ServiceEdgeGroupServiceEdgesArgs']]:
        """
        WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
        matching.This field will be deprecated in future versions
        """
        return pulumi.get(self, "service_edges")

    @service_edges.setter
    def service_edges(self, value: Optional[pulumi.Input['ServiceEdgeGroupServiceEdgesArgs']]):
        pulumi.set(self, "service_edges", value)

    @property
    @pulumi.getter(name="trustedNetworks")
    def trusted_networks(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]:
        """
        List of trusted network IDs.
        """
        return pulumi.get(self, "trusted_networks")

    @trusted_networks.setter
    def trusted_networks(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ServiceEdgeGroupTrustedNetworkArgs']]]]):
        pulumi.set(self, "trusted_networks", value)

    @property
    @pulumi.getter(name="upgradeDay")
    def upgrade_day(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        """
        return pulumi.get(self, "upgrade_day")

    @upgrade_day.setter
    def upgrade_day(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "upgrade_day", value)

    @property
    @pulumi.getter(name="upgradeTimeInSecs")
    def upgrade_time_in_secs(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        """
        return pulumi.get(self, "upgrade_time_in_secs")

    @upgrade_time_in_secs.setter
    def upgrade_time_in_secs(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "upgrade_time_in_secs", value)

    @property
    @pulumi.getter(name="useInDrMode")
    def use_in_dr_mode(self) -> Optional[pulumi.Input[builtins.bool]]:
        return pulumi.get(self, "use_in_dr_mode")

    @use_in_dr_mode.setter
    def use_in_dr_mode(self, value: Optional[pulumi.Input[builtins.bool]]):
        pulumi.set(self, "use_in_dr_mode", value)

    @property
    @pulumi.getter(name="versionProfileId")
    def version_profile_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_id")

    @version_profile_id.setter
    def version_profile_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version_profile_id", value)

    @property
    @pulumi.getter(name="versionProfileName")
    def version_profile_name(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
        overrideVersionProfile is set to true
        """
        return pulumi.get(self, "version_profile_name")

    @version_profile_name.setter
    def version_profile_name(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version_profile_name", value)

    @property
    @pulumi.getter(name="versionProfileVisibilityScope")
    def version_profile_visibility_scope(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_visibility_scope")

    @version_profile_visibility_scope.setter
    def version_profile_visibility_scope(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "version_profile_visibility_scope", value)


@pulumi.type_token("zpa:index/serviceEdgeGroup:ServiceEdgeGroup")
class ServiceEdgeGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 city_country: Optional[pulumi.Input[builtins.str]] = None,
                 country_code: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_value: Optional[pulumi.Input[builtins.str]] = None,
                 grace_distance_value_unit: Optional[pulumi.Input[builtins.str]] = None,
                 is_public: Optional[pulumi.Input[builtins.bool]] = None,
                 latitude: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 longitude: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 override_version_profile: Optional[pulumi.Input[builtins.bool]] = None,
                 service_edges: Optional[pulumi.Input[Union['ServiceEdgeGroupServiceEdgesArgs', 'ServiceEdgeGroupServiceEdgesArgsDict']]] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ServiceEdgeGroupTrustedNetworkArgs', 'ServiceEdgeGroupTrustedNetworkArgsDict']]]]] = None,
                 upgrade_day: Optional[pulumi.Input[builtins.str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[builtins.str]] = None,
                 use_in_dr_mode: Optional[pulumi.Input[builtins.bool]] = None,
                 version_profile_id: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_visibility_scope: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-zpa-private-service-edge-groups)
        * [API documentation](https://help.zscaler.com/zpa/configuring-zpa-private-service-edge-groups-using-api)

        The **zpa_service_edge_group** resource creates a service edge group in the Zscaler Private Access cloud. This resource can then be referenced in a service edge connector.

        ## Example Usage

        ### Using Version Profile Name

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - Trusted Network
        service_edge_group_sjc = zpa.ServiceEdgeGroup("serviceEdgeGroupSjc",
            description="Service Edge Group in San Jose",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="37.3382082",
            longitude="-121.8863286",
            location="San Jose, CA, USA",
            version_profile_name="New Release",
            trusted_networks=[{
                "ids": [data["zpa_trusted_network"]["example"]["id"]],
            }])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - No Trusted Network
        service_edge_group_nyc = zpa.ServiceEdgeGroup("serviceEdgeGroupNyc",
            description="Service Edge Group in New York",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="40.7128",
            longitude="-73.935242",
            location="New York, NY, USA",
            version_profile_id=data["zpa_customer_version_profile"]["this"]["id"])
        ```

        ### Using Version Profile ID

        data "get_customer_version_profile" "this" {
          name = "New Release"
        }

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - Trusted Network
        service_edge_group_sjc = zpa.ServiceEdgeGroup("serviceEdgeGroupSjc",
            description="Service Edge Group in San Jose",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="37.3382082",
            longitude="-121.8863286",
            location="San Jose, CA, USA",
            version_profile_name="New Release",
            trusted_networks=[{
                "ids": [data["zpa_trusted_network"]["example"]["id"]],
            }])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - No Trusted Network
        service_edge_group_nyc = zpa.ServiceEdgeGroup("serviceEdgeGroupNyc",
            description="Service Edge Group in New York",
            enabled=True,
            is_public=True,
            latitude="40.7128",
            location="New York, NY, USA",
            longitude="-73.935242",
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            version_profile_name="New Release")
        ```

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        Service Edge Group can be imported; use `<SERVER EDGE GROUP ID>` or `<SERVER EDGE GROUP NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_id>
        ```

        or

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_name>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] description: Description of the Service Edge Group.
        :param pulumi.Input[builtins.bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[builtins.bool] grace_distance_enabled: If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
               Public Service Edge.
        :param pulumi.Input[builtins.str] grace_distance_value: Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
               Public Service Edge
        :param pulumi.Input[builtins.str] grace_distance_value_unit: Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
               is set to true
        :param pulumi.Input[builtins.bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[builtins.str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] location: Location for the Service Edge Group.
        :param pulumi.Input[builtins.str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] name: Name of the Service Edge Group.
        :param pulumi.Input[builtins.bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input[Union['ServiceEdgeGroupServiceEdgesArgs', 'ServiceEdgeGroupServiceEdgesArgsDict']] service_edges: WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
               matching.This field will be deprecated in future versions
        :param pulumi.Input[Sequence[pulumi.Input[Union['ServiceEdgeGroupTrustedNetworkArgs', 'ServiceEdgeGroupTrustedNetworkArgsDict']]]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[builtins.str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[builtins.str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[builtins.str] version_profile_id: ID of the version profile.
        :param pulumi.Input[builtins.str] version_profile_name: Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
               overrideVersionProfile is set to true
        :param pulumi.Input[builtins.str] version_profile_visibility_scope: ID of the version profile.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ServiceEdgeGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        * [Official documentation](https://help.zscaler.com/zpa/about-zpa-private-service-edge-groups)
        * [API documentation](https://help.zscaler.com/zpa/configuring-zpa-private-service-edge-groups-using-api)

        The **zpa_service_edge_group** resource creates a service edge group in the Zscaler Private Access cloud. This resource can then be referenced in a service edge connector.

        ## Example Usage

        ### Using Version Profile Name

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - Trusted Network
        service_edge_group_sjc = zpa.ServiceEdgeGroup("serviceEdgeGroupSjc",
            description="Service Edge Group in San Jose",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="37.3382082",
            longitude="-121.8863286",
            location="San Jose, CA, USA",
            version_profile_name="New Release",
            trusted_networks=[{
                "ids": [data["zpa_trusted_network"]["example"]["id"]],
            }])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - No Trusted Network
        service_edge_group_nyc = zpa.ServiceEdgeGroup("serviceEdgeGroupNyc",
            description="Service Edge Group in New York",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="40.7128",
            longitude="-73.935242",
            location="New York, NY, USA",
            version_profile_id=data["zpa_customer_version_profile"]["this"]["id"])
        ```

        ### Using Version Profile ID

        data "get_customer_version_profile" "this" {
          name = "New Release"
        }

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - Trusted Network
        service_edge_group_sjc = zpa.ServiceEdgeGroup("serviceEdgeGroupSjc",
            description="Service Edge Group in San Jose",
            enabled=True,
            is_public=True,
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            latitude="37.3382082",
            longitude="-121.8863286",
            location="San Jose, CA, USA",
            version_profile_name="New Release",
            trusted_networks=[{
                "ids": [data["zpa_trusted_network"]["example"]["id"]],
            }])
        ```

        ```python
        import pulumi
        import zscaler_pulumi_zpa as zpa

        # ZPA Service Edge Group resource - No Trusted Network
        service_edge_group_nyc = zpa.ServiceEdgeGroup("serviceEdgeGroupNyc",
            description="Service Edge Group in New York",
            enabled=True,
            is_public=True,
            latitude="40.7128",
            location="New York, NY, USA",
            longitude="-73.935242",
            upgrade_day="SUNDAY",
            upgrade_time_in_secs="66600",
            version_profile_name="New Release")
        ```

        ## Import

        Zscaler offers a dedicated tool called Zscaler-Terraformer to allow the automated import of ZPA configurations into Terraform-compliant HashiCorp Configuration Language.

        Visit

        Service Edge Group can be imported; use `<SERVER EDGE GROUP ID>` or `<SERVER EDGE GROUP NAME>` as the import ID.

        For example:

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_id>
        ```

        or

        ```sh
        $ pulumi import zpa:index/serviceEdgeGroup:ServiceEdgeGroup example <service_edge_group_name>
        ```

        :param str resource_name: The name of the resource.
        :param ServiceEdgeGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ServiceEdgeGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 city_country: Optional[pulumi.Input[builtins.str]] = None,
                 country_code: Optional[pulumi.Input[builtins.str]] = None,
                 description: Optional[pulumi.Input[builtins.str]] = None,
                 enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_enabled: Optional[pulumi.Input[builtins.bool]] = None,
                 grace_distance_value: Optional[pulumi.Input[builtins.str]] = None,
                 grace_distance_value_unit: Optional[pulumi.Input[builtins.str]] = None,
                 is_public: Optional[pulumi.Input[builtins.bool]] = None,
                 latitude: Optional[pulumi.Input[builtins.str]] = None,
                 location: Optional[pulumi.Input[builtins.str]] = None,
                 longitude: Optional[pulumi.Input[builtins.str]] = None,
                 microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
                 name: Optional[pulumi.Input[builtins.str]] = None,
                 override_version_profile: Optional[pulumi.Input[builtins.bool]] = None,
                 service_edges: Optional[pulumi.Input[Union['ServiceEdgeGroupServiceEdgesArgs', 'ServiceEdgeGroupServiceEdgesArgsDict']]] = None,
                 trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ServiceEdgeGroupTrustedNetworkArgs', 'ServiceEdgeGroupTrustedNetworkArgsDict']]]]] = None,
                 upgrade_day: Optional[pulumi.Input[builtins.str]] = None,
                 upgrade_time_in_secs: Optional[pulumi.Input[builtins.str]] = None,
                 use_in_dr_mode: Optional[pulumi.Input[builtins.bool]] = None,
                 version_profile_id: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_name: Optional[pulumi.Input[builtins.str]] = None,
                 version_profile_visibility_scope: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ServiceEdgeGroupArgs.__new__(ServiceEdgeGroupArgs)

            __props__.__dict__["city_country"] = city_country
            __props__.__dict__["country_code"] = country_code
            __props__.__dict__["description"] = description
            __props__.__dict__["enabled"] = enabled
            __props__.__dict__["grace_distance_enabled"] = grace_distance_enabled
            __props__.__dict__["grace_distance_value"] = grace_distance_value
            __props__.__dict__["grace_distance_value_unit"] = grace_distance_value_unit
            __props__.__dict__["is_public"] = is_public
            if latitude is None and not opts.urn:
                raise TypeError("Missing required property 'latitude'")
            __props__.__dict__["latitude"] = latitude
            if location is None and not opts.urn:
                raise TypeError("Missing required property 'location'")
            __props__.__dict__["location"] = location
            if longitude is None and not opts.urn:
                raise TypeError("Missing required property 'longitude'")
            __props__.__dict__["longitude"] = longitude
            __props__.__dict__["microtenant_id"] = microtenant_id
            __props__.__dict__["name"] = name
            __props__.__dict__["override_version_profile"] = override_version_profile
            __props__.__dict__["service_edges"] = service_edges
            __props__.__dict__["trusted_networks"] = trusted_networks
            __props__.__dict__["upgrade_day"] = upgrade_day
            __props__.__dict__["upgrade_time_in_secs"] = upgrade_time_in_secs
            __props__.__dict__["use_in_dr_mode"] = use_in_dr_mode
            __props__.__dict__["version_profile_id"] = version_profile_id
            __props__.__dict__["version_profile_name"] = version_profile_name
            __props__.__dict__["version_profile_visibility_scope"] = version_profile_visibility_scope
        super(ServiceEdgeGroup, __self__).__init__(
            'zpa:index/serviceEdgeGroup:ServiceEdgeGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            city_country: Optional[pulumi.Input[builtins.str]] = None,
            country_code: Optional[pulumi.Input[builtins.str]] = None,
            description: Optional[pulumi.Input[builtins.str]] = None,
            enabled: Optional[pulumi.Input[builtins.bool]] = None,
            grace_distance_enabled: Optional[pulumi.Input[builtins.bool]] = None,
            grace_distance_value: Optional[pulumi.Input[builtins.str]] = None,
            grace_distance_value_unit: Optional[pulumi.Input[builtins.str]] = None,
            is_public: Optional[pulumi.Input[builtins.bool]] = None,
            latitude: Optional[pulumi.Input[builtins.str]] = None,
            location: Optional[pulumi.Input[builtins.str]] = None,
            longitude: Optional[pulumi.Input[builtins.str]] = None,
            microtenant_id: Optional[pulumi.Input[builtins.str]] = None,
            name: Optional[pulumi.Input[builtins.str]] = None,
            override_version_profile: Optional[pulumi.Input[builtins.bool]] = None,
            service_edges: Optional[pulumi.Input[Union['ServiceEdgeGroupServiceEdgesArgs', 'ServiceEdgeGroupServiceEdgesArgsDict']]] = None,
            trusted_networks: Optional[pulumi.Input[Sequence[pulumi.Input[Union['ServiceEdgeGroupTrustedNetworkArgs', 'ServiceEdgeGroupTrustedNetworkArgsDict']]]]] = None,
            upgrade_day: Optional[pulumi.Input[builtins.str]] = None,
            upgrade_time_in_secs: Optional[pulumi.Input[builtins.str]] = None,
            use_in_dr_mode: Optional[pulumi.Input[builtins.bool]] = None,
            version_profile_id: Optional[pulumi.Input[builtins.str]] = None,
            version_profile_name: Optional[pulumi.Input[builtins.str]] = None,
            version_profile_visibility_scope: Optional[pulumi.Input[builtins.str]] = None) -> 'ServiceEdgeGroup':
        """
        Get an existing ServiceEdgeGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.str] description: Description of the Service Edge Group.
        :param pulumi.Input[builtins.bool] enabled: Whether this Service Edge Group is enabled or not.
        :param pulumi.Input[builtins.bool] grace_distance_enabled: If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
               Public Service Edge.
        :param pulumi.Input[builtins.str] grace_distance_value: Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
               Public Service Edge
        :param pulumi.Input[builtins.str] grace_distance_value_unit: Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
               is set to true
        :param pulumi.Input[builtins.bool] is_public: Enable or disable public access for the Service Edge Group.
        :param pulumi.Input[builtins.str] latitude: Latitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] location: Location for the Service Edge Group.
        :param pulumi.Input[builtins.str] longitude: Longitude for the Service Edge Group.
        :param pulumi.Input[builtins.str] name: Name of the Service Edge Group.
        :param pulumi.Input[builtins.bool] override_version_profile: Whether the default version profile of the App Connector Group is applied or overridden.
        :param pulumi.Input[Union['ServiceEdgeGroupServiceEdgesArgs', 'ServiceEdgeGroupServiceEdgesArgsDict']] service_edges: WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
               matching.This field will be deprecated in future versions
        :param pulumi.Input[Sequence[pulumi.Input[Union['ServiceEdgeGroupTrustedNetworkArgs', 'ServiceEdgeGroupTrustedNetworkArgsDict']]]] trusted_networks: List of trusted network IDs.
        :param pulumi.Input[builtins.str] upgrade_day: Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        :param pulumi.Input[builtins.str] upgrade_time_in_secs: Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        :param pulumi.Input[builtins.str] version_profile_id: ID of the version profile.
        :param pulumi.Input[builtins.str] version_profile_name: Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
               overrideVersionProfile is set to true
        :param pulumi.Input[builtins.str] version_profile_visibility_scope: ID of the version profile.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ServiceEdgeGroupState.__new__(_ServiceEdgeGroupState)

        __props__.__dict__["city_country"] = city_country
        __props__.__dict__["country_code"] = country_code
        __props__.__dict__["description"] = description
        __props__.__dict__["enabled"] = enabled
        __props__.__dict__["grace_distance_enabled"] = grace_distance_enabled
        __props__.__dict__["grace_distance_value"] = grace_distance_value
        __props__.__dict__["grace_distance_value_unit"] = grace_distance_value_unit
        __props__.__dict__["is_public"] = is_public
        __props__.__dict__["latitude"] = latitude
        __props__.__dict__["location"] = location
        __props__.__dict__["longitude"] = longitude
        __props__.__dict__["microtenant_id"] = microtenant_id
        __props__.__dict__["name"] = name
        __props__.__dict__["override_version_profile"] = override_version_profile
        __props__.__dict__["service_edges"] = service_edges
        __props__.__dict__["trusted_networks"] = trusted_networks
        __props__.__dict__["upgrade_day"] = upgrade_day
        __props__.__dict__["upgrade_time_in_secs"] = upgrade_time_in_secs
        __props__.__dict__["use_in_dr_mode"] = use_in_dr_mode
        __props__.__dict__["version_profile_id"] = version_profile_id
        __props__.__dict__["version_profile_name"] = version_profile_name
        __props__.__dict__["version_profile_visibility_scope"] = version_profile_visibility_scope
        return ServiceEdgeGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cityCountry")
    def city_country(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "city_country")

    @property
    @pulumi.getter(name="countryCode")
    def country_code(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "country_code")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Description of the Service Edge Group.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def enabled(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether this Service Edge Group is enabled or not.
        """
        return pulumi.get(self, "enabled")

    @property
    @pulumi.getter(name="graceDistanceEnabled")
    def grace_distance_enabled(self) -> pulumi.Output[builtins.bool]:
        """
        If enabled, allows ZPA Private Service Edge Groups within the specified distance to be prioritized over a closer ZPA
        Public Service Edge.
        """
        return pulumi.get(self, "grace_distance_enabled")

    @property
    @pulumi.getter(name="graceDistanceValue")
    def grace_distance_value(self) -> pulumi.Output[builtins.str]:
        """
        Indicates the maximum distance in miles or kilometers to ZPA Private Service Edge groups that would override a ZPA
        Public Service Edge
        """
        return pulumi.get(self, "grace_distance_value")

    @property
    @pulumi.getter(name="graceDistanceValueUnit")
    def grace_distance_value_unit(self) -> pulumi.Output[builtins.str]:
        """
        Indicates the grace distance unit of measure in miles or kilometers. This value is only required if grace_distance_value
        is set to true
        """
        return pulumi.get(self, "grace_distance_value_unit")

    @property
    @pulumi.getter(name="isPublic")
    def is_public(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Enable or disable public access for the Service Edge Group.
        """
        return pulumi.get(self, "is_public")

    @property
    @pulumi.getter
    def latitude(self) -> pulumi.Output[builtins.str]:
        """
        Latitude for the Service Edge Group.
        """
        return pulumi.get(self, "latitude")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[builtins.str]:
        """
        Location for the Service Edge Group.
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def longitude(self) -> pulumi.Output[builtins.str]:
        """
        Longitude for the Service Edge Group.
        """
        return pulumi.get(self, "longitude")

    @property
    @pulumi.getter(name="microtenantId")
    def microtenant_id(self) -> pulumi.Output[builtins.str]:
        return pulumi.get(self, "microtenant_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[builtins.str]:
        """
        Name of the Service Edge Group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="overrideVersionProfile")
    def override_version_profile(self) -> pulumi.Output[Optional[builtins.bool]]:
        """
        Whether the default version profile of the App Connector Group is applied or overridden.
        """
        return pulumi.get(self, "override_version_profile")

    @property
    @pulumi.getter(name="serviceEdges")
    def service_edges(self) -> pulumi.Output['outputs.ServiceEdgeGroupServiceEdges']:
        """
        WARNING: Service edge membership is managed externally. Specifying this field will enforce exact membership
        matching.This field will be deprecated in future versions
        """
        return pulumi.get(self, "service_edges")

    @property
    @pulumi.getter(name="trustedNetworks")
    def trusted_networks(self) -> pulumi.Output[Optional[Sequence['outputs.ServiceEdgeGroupTrustedNetwork']]]:
        """
        List of trusted network IDs.
        """
        return pulumi.get(self, "trusted_networks")

    @property
    @pulumi.getter(name="upgradeDay")
    def upgrade_day(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified day.
        """
        return pulumi.get(self, "upgrade_day")

    @property
    @pulumi.getter(name="upgradeTimeInSecs")
    def upgrade_time_in_secs(self) -> pulumi.Output[Optional[builtins.str]]:
        """
        Service Edges in this group will attempt to update to a newer version of the software during this specified time.
        """
        return pulumi.get(self, "upgrade_time_in_secs")

    @property
    @pulumi.getter(name="useInDrMode")
    def use_in_dr_mode(self) -> pulumi.Output[builtins.bool]:
        return pulumi.get(self, "use_in_dr_mode")

    @property
    @pulumi.getter(name="versionProfileId")
    def version_profile_id(self) -> pulumi.Output[builtins.str]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_id")

    @property
    @pulumi.getter(name="versionProfileName")
    def version_profile_name(self) -> pulumi.Output[builtins.str]:
        """
        Name of the version profile. To learn more, see Version Profile Use Cases. This value is required, if the value for
        overrideVersionProfile is set to true
        """
        return pulumi.get(self, "version_profile_name")

    @property
    @pulumi.getter(name="versionProfileVisibilityScope")
    def version_profile_visibility_scope(self) -> pulumi.Output[builtins.str]:
        """
        ID of the version profile.
        """
        return pulumi.get(self, "version_profile_visibility_scope")

